#define G_UNICODE_LAST_CHAR 0x10ffffUL

#define G_UNICODE_MAX_TABLE_INDEX 10000

#define G_UNICODE_LAST_CHAR_PART1 0x2FAFFUL

#define G_UNICODE_LAST_PAGE_PART1 762

typedef enum
{
  G_UNICODE_CONTROL,
  G_UNICODE_FORMAT,
  G_UNICODE_UNASSIGNED,
  G_UNICODE_PRIVATE_USE,
  G_UNICODE_SURROGATE,
  G_UNICODE_LOWERCASE_LETTER,
  G_UNICODE_MODIFIER_LETTER,
  G_UNICODE_OTHER_LETTER,
  G_UNICODE_TITLECASE_LETTER,
  G_UNICODE_UPPERCASE_LETTER,
  G_UNICODE_SPACING_MARK,
  G_UNICODE_ENCLOSING_MARK,
  G_UNICODE_NON_SPACING_MARK,
  G_UNICODE_DECIMAL_NUMBER,
  G_UNICODE_LETTER_NUMBER,
  G_UNICODE_OTHER_NUMBER,
  G_UNICODE_CONNECT_PUNCTUATION,
  G_UNICODE_DASH_PUNCTUATION,
  G_UNICODE_CLOSE_PUNCTUATION,
  G_UNICODE_FINAL_PUNCTUATION,
  G_UNICODE_INITIAL_PUNCTUATION,
  G_UNICODE_OTHER_PUNCTUATION,
  G_UNICODE_OPEN_PUNCTUATION,
  G_UNICODE_CURRENCY_SYMBOL,
  G_UNICODE_MODIFIER_SYMBOL,
  G_UNICODE_MATH_SYMBOL,
  G_UNICODE_OTHER_SYMBOL,
  G_UNICODE_LINE_SEPARATOR,
  G_UNICODE_PARAGRAPH_SEPARATOR,
  G_UNICODE_SPACE_SEPARATOR
} GUnicodeType;

static const char type_data[][256] = {
  { /* page 0, index 0 */
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_CONTROL, 
    G_UNICODE_CONTROL, G_UNICODE_CONTROL, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_MATH_SYMBOL, G_UNICODE_FORMAT, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_FINAL_PUNCTUATION, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 1, index 1 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 2, index 2 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL
  },
  { /* page 3, index 3 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER
  },
  { /* page 4, index 4 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 5, index 5 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 6, index 6 */
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_UNASSIGNED, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_FORMAT, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 7, index 7 */
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_FORMAT, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 8, index 8 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 9, index 9 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 10, index 10 */
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 11, index 11 */
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 12, index 12 */
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 13, index 13 */
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 14, index 14 */
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 15, index 15 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 16, index 16 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER
  },
  { /* page 18, index 17 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 19, index 18 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 20, index 19 */
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER
  },
  { /* page 22, index 20 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 23, index 21 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 24, index 22 */
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_UNASSIGNED, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 25, index 23 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL
  },
  { /* page 26, index 24 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 27, index 25 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION
  },
  { /* page 28, index 26 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 29, index 27 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK
  },
  { /* page 30, index 28 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 31, index 29 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_TITLECASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_TITLECASE_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_UNASSIGNED
  },
  { /* page 32, index 30 */
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_SPACE_SEPARATOR, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_INITIAL_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_INITIAL_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_LINE_SEPARATOR, G_UNICODE_PARAGRAPH_SEPARATOR, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_SPACE_SEPARATOR, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_CONNECT_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_CONNECT_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_OTHER_NUMBER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_UNASSIGNED, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 33, index 31 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL
  },
  { /* page 35, index 32 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 36, index 33 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER
  },
  { /* page 37, index 34 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL
  },
  { /* page 38, index 35 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL
  },
  { /* page 39, index 36 */
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL
  },
  { /* page 41, index 37 */
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL
  },
  { /* page 43, index 38 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 44, index 39 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION
  },
  { /* page 45, index 40 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK
  },
  { /* page 46, index 41 */
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_INITIAL_PUNCTUATION, 
    G_UNICODE_FINAL_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_INITIAL_PUNCTUATION, G_UNICODE_FINAL_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 47, index 42 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 48, index 43 */
    G_UNICODE_SPACE_SEPARATOR, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 49, index 44 */
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 50, index 45 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 77, index 46 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL
  },
  { /* page 159, index 47 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 160, index 48 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER
  },
  { /* page 164, index 49 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION
  },
  { /* page 166, index 50 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_ENCLOSING_MARK, G_UNICODE_ENCLOSING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 167, index 51 */
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 168, index 52 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 169, index 53 */
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 170, index 54 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 171, index 55 */
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 215, index 56 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 250, index 57 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 251, index 58 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER
  },
  { /* page 253, index 59 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 254, index 60 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_CONNECT_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_CONNECT_PUNCTUATION, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_DASH_PUNCTUATION, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_FORMAT
  },
  { /* page 255, index 61 */
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_DASH_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_CONNECT_PUNCTUATION, G_UNICODE_MODIFIER_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OPEN_PUNCTUATION, G_UNICODE_CLOSE_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OPEN_PUNCTUATION, 
    G_UNICODE_CLOSE_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MODIFIER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_CURRENCY_SYMBOL, G_UNICODE_CURRENCY_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 256, index 62 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 257, index 63 */
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 258, index 64 */
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 259, index 65 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 260, index 66 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 264, index 67 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 265, index 68 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 266, index 69 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 267, index 70 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 268, index 71 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 270, index 72 */
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 272, index 73 */
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_FORMAT, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 273, index 74 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 278, index 75 */
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 291, index 76 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 292, index 77 */
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_LETTER_NUMBER, 
    G_UNICODE_LETTER_NUMBER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_OTHER_PUNCTUATION, 
    G_UNICODE_OTHER_PUNCTUATION, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 308, index 78 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 362, index 79 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 367, index 80 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_MODIFIER_LETTER, G_UNICODE_MODIFIER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 432, index 81 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 464, index 82 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 465, index 83 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, G_UNICODE_SPACING_MARK, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 466, index 84 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 467, index 85 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 468, index 86 */
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 469, index 87 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 470, index 88 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER
  },
  { /* page 471, index 89 */
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_UPPERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_MATH_SYMBOL, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_LOWERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UPPERCASE_LETTER, G_UNICODE_LOWERCASE_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER, G_UNICODE_DECIMAL_NUMBER, 
    G_UNICODE_DECIMAL_NUMBER
  },
  { /* page 494, index 90 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_MATH_SYMBOL, G_UNICODE_MATH_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 496, index 91 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 497, index 92 */
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, 
    G_UNICODE_OTHER_NUMBER, G_UNICODE_OTHER_NUMBER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL
  },
  { /* page 498, index 93 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 499, index 94 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 500, index 95 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 501, index 96 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL
  },
  { /* page 502, index 97 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 503, index 98 */
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, 
    G_UNICODE_OTHER_SYMBOL, G_UNICODE_OTHER_SYMBOL, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 678, index 99 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 695, index 100 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER
  },
  { /* page 696, index 101 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 762, index 102 */
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, G_UNICODE_OTHER_LETTER, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 3584, index 103 */
    G_UNICODE_UNASSIGNED, G_UNICODE_FORMAT, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_FORMAT, G_UNICODE_FORMAT, G_UNICODE_FORMAT, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED
  },
  { /* page 3585, index 104 */
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_NON_SPACING_MARK, G_UNICODE_NON_SPACING_MARK, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 4095, index 105 */
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  },
  { /* page 4351, index 106 */
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, 
    G_UNICODE_PRIVATE_USE, G_UNICODE_PRIVATE_USE, G_UNICODE_UNASSIGNED, 
    G_UNICODE_UNASSIGNED
  }
};

static short const type_table_part1[763] = {
  0 /* page 0 */,
  1 /* page 1 */,
  2 /* page 2 */,
  3 /* page 3 */,
  4 /* page 4 */,
  5 /* page 5 */,
  6 /* page 6 */,
  7 /* page 7 */,
  8 /* page 8 */,
  9 /* page 9 */,
  10 /* page 10 */,
  11 /* page 11 */,
  12 /* page 12 */,
  13 /* page 13 */,
  14 /* page 14 */,
  15 /* page 15 */,
  16 /* page 16 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  17 /* page 18 */,
  18 /* page 19 */,
  19 /* page 20 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  20 /* page 22 */,
  21 /* page 23 */,
  22 /* page 24 */,
  23 /* page 25 */,
  24 /* page 26 */,
  25 /* page 27 */,
  26 /* page 28 */,
  27 /* page 29 */,
  28 /* page 30 */,
  29 /* page 31 */,
  30 /* page 32 */,
  31 /* page 33 */,
  G_UNICODE_MATH_SYMBOL + G_UNICODE_MAX_TABLE_INDEX,
  32 /* page 35 */,
  33 /* page 36 */,
  34 /* page 37 */,
  35 /* page 38 */,
  36 /* page 39 */,
  G_UNICODE_OTHER_SYMBOL + G_UNICODE_MAX_TABLE_INDEX,
  37 /* page 41 */,
  G_UNICODE_MATH_SYMBOL + G_UNICODE_MAX_TABLE_INDEX,
  38 /* page 43 */,
  39 /* page 44 */,
  40 /* page 45 */,
  41 /* page 46 */,
  42 /* page 47 */,
  43 /* page 48 */,
  44 /* page 49 */,
  45 /* page 50 */,
  G_UNICODE_OTHER_SYMBOL + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  46 /* page 77 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  47 /* page 159 */,
  48 /* page 160 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  49 /* page 164 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  50 /* page 166 */,
  51 /* page 167 */,
  52 /* page 168 */,
  53 /* page 169 */,
  54 /* page 170 */,
  55 /* page 171 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  56 /* page 215 */,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_SURROGATE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  57 /* page 250 */,
  58 /* page 251 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  59 /* page 253 */,
  60 /* page 254 */,
  61 /* page 255 */,
  62 /* page 256 */,
  63 /* page 257 */,
  64 /* page 258 */,
  65 /* page 259 */,
  66 /* page 260 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  67 /* page 264 */,
  68 /* page 265 */,
  69 /* page 266 */,
  70 /* page 267 */,
  71 /* page 268 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  72 /* page 270 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  73 /* page 272 */,
  74 /* page 273 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  75 /* page 278 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  76 /* page 291 */,
  77 /* page 292 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  78 /* page 308 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  79 /* page 362 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  80 /* page 367 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  81 /* page 432 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  82 /* page 464 */,
  83 /* page 465 */,
  84 /* page 466 */,
  85 /* page 467 */,
  86 /* page 468 */,
  87 /* page 469 */,
  88 /* page 470 */,
  89 /* page 471 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  90 /* page 494 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  91 /* page 496 */,
  92 /* page 497 */,
  93 /* page 498 */,
  94 /* page 499 */,
  95 /* page 500 */,
  96 /* page 501 */,
  97 /* page 502 */,
  98 /* page 503 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  99 /* page 678 */,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  100 /* page 695 */,
  101 /* page 696 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_OTHER_LETTER + G_UNICODE_MAX_TABLE_INDEX,
  102 /* page 762 */
};

/* U+E0000 through U+10FFFF */
static short const type_table_part2[768] = {
  103 /* page 3584 */,
  104 /* page 3585 */,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_UNASSIGNED + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  105 /* page 4095 */,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  G_UNICODE_PRIVATE_USE + G_UNICODE_MAX_TABLE_INDEX,
  106 /* page 4351 */
};

static const h_unichar_t attr_data[][256] = {
  { /* page 0, index 0 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0061UL, 0x0062UL, 0x0063UL, 0x0064UL, 0x0065UL, 0x0066UL, 0x0067UL, 
    0x0068UL, 0x0069UL, 0x006aUL, 0x006bUL, 0x006cUL, 0x006dUL, 0x006eUL, 0x006fUL, 0x0070UL, 
    0x0071UL, 0x0072UL, 0x0073UL, 0x0074UL, 0x0075UL, 0x0076UL, 0x0077UL, 0x0078UL, 0x0079UL, 
    0x007aUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0041UL, 0x0042UL, 
    0x0043UL, 0x0044UL, 0x0045UL, 0x0046UL, 0x0047UL, 0x0048UL, 0x0049UL, 0x004aUL, 0x004bUL, 
    0x004cUL, 0x004dUL, 0x004eUL, 0x004fUL, 0x0050UL, 0x0051UL, 0x0052UL, 0x0053UL, 0x0054UL, 
    0x0055UL, 0x0056UL, 0x0057UL, 0x0058UL, 0x0059UL, 0x005aUL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x039cUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x00e0UL, 0x00e1UL, 0x00e2UL, 0x00e3UL, 0x00e4UL, 0x00e5UL, 
    0x00e6UL, 0x00e7UL, 0x00e8UL, 0x00e9UL, 0x00eaUL, 0x00ebUL, 0x00ecUL, 0x00edUL, 0x00eeUL, 
    0x00efUL, 0x00f0UL, 0x00f1UL, 0x00f2UL, 0x00f3UL, 0x00f4UL, 0x00f5UL, 0x00f6UL, 0x0000UL, 
    0x00f8UL, 0x00f9UL, 0x00faUL, 0x00fbUL, 0x00fcUL, 0x00fdUL, 0x00feUL, 0x1000000UL, 
    0x00c0UL, 0x00c1UL, 0x00c2UL, 0x00c3UL, 0x00c4UL, 0x00c5UL, 0x00c6UL, 0x00c7UL, 0x00c8UL, 
    0x00c9UL, 0x00caUL, 0x00cbUL, 0x00ccUL, 0x00cdUL, 0x00ceUL, 0x00cfUL, 0x00d0UL, 0x00d1UL, 
    0x00d2UL, 0x00d3UL, 0x00d4UL, 0x00d5UL, 0x00d6UL, 0x0000UL, 0x00d8UL, 0x00d9UL, 0x00daUL, 
    0x00dbUL, 0x00dcUL, 0x00ddUL, 0x00deUL, 0x0178UL
  },
  { /* page 1, index 1 */
    0x0101UL, 0x0100UL, 0x0103UL, 0x0102UL, 0x0105UL, 0x0104UL, 0x0107UL, 0x0106UL, 0x0109UL, 
    0x0108UL, 0x010bUL, 0x010aUL, 0x010dUL, 0x010cUL, 0x010fUL, 0x010eUL, 0x0111UL, 0x0110UL, 
    0x0113UL, 0x0112UL, 0x0115UL, 0x0114UL, 0x0117UL, 0x0116UL, 0x0119UL, 0x0118UL, 0x011bUL, 
    0x011aUL, 0x011dUL, 0x011cUL, 0x011fUL, 0x011eUL, 0x0121UL, 0x0120UL, 0x0123UL, 0x0122UL, 
    0x0125UL, 0x0124UL, 0x0127UL, 0x0126UL, 0x0129UL, 0x0128UL, 0x012bUL, 0x012aUL, 0x012dUL, 
    0x012cUL, 0x012fUL, 0x012eUL, 0x1000007UL, 0x0049UL, 0x0133UL, 0x0132UL, 0x0135UL, 
    0x0134UL, 0x0137UL, 0x0136UL, 0x0000UL, 0x013aUL, 0x0139UL, 0x013cUL, 0x013bUL, 0x013eUL, 
    0x013dUL, 0x0140UL, 0x013fUL, 0x0142UL, 0x0141UL, 0x0144UL, 0x0143UL, 0x0146UL, 0x0145UL, 
    0x0148UL, 0x0147UL, 0x1000086UL, 0x014bUL, 0x014aUL, 0x014dUL, 0x014cUL, 0x014fUL, 
    0x014eUL, 0x0151UL, 0x0150UL, 0x0153UL, 0x0152UL, 0x0155UL, 0x0154UL, 0x0157UL, 0x0156UL, 
    0x0159UL, 0x0158UL, 0x015bUL, 0x015aUL, 0x015dUL, 0x015cUL, 0x015fUL, 0x015eUL, 0x0161UL, 
    0x0160UL, 0x0163UL, 0x0162UL, 0x0165UL, 0x0164UL, 0x0167UL, 0x0166UL, 0x0169UL, 0x0168UL, 
    0x016bUL, 0x016aUL, 0x016dUL, 0x016cUL, 0x016fUL, 0x016eUL, 0x0171UL, 0x0170UL, 0x0173UL, 
    0x0172UL, 0x0175UL, 0x0174UL, 0x0177UL, 0x0176UL, 0x00ffUL, 0x017aUL, 0x0179UL, 0x017cUL, 
    0x017bUL, 0x017eUL, 0x017dUL, 0x0053UL, 0x0243UL, 0x0253UL, 0x0183UL, 0x0182UL, 0x0185UL, 
    0x0184UL, 0x0254UL, 0x0188UL, 0x0187UL, 0x0256UL, 0x0257UL, 0x018cUL, 0x018bUL, 0x0000UL, 
    0x01ddUL, 0x0259UL, 0x025bUL, 0x0192UL, 0x0191UL, 0x0260UL, 0x0263UL, 0x01f6UL, 0x0269UL, 
    0x0268UL, 0x0199UL, 0x0198UL, 0x023dUL, 0x0000UL, 0x026fUL, 0x0272UL, 0x0220UL, 0x0275UL, 
    0x01a1UL, 0x01a0UL, 0x01a3UL, 0x01a2UL, 0x01a5UL, 0x01a4UL, 0x0280UL, 0x01a8UL, 0x01a7UL, 
    0x0283UL, 0x0000UL, 0x0000UL, 0x01adUL, 0x01acUL, 0x0288UL, 0x01b0UL, 0x01afUL, 0x028aUL, 
    0x028bUL, 0x01b4UL, 0x01b3UL, 0x01b6UL, 0x01b5UL, 0x0292UL, 0x01b9UL, 0x01b8UL, 0x0000UL, 
    0x0000UL, 0x01bdUL, 0x01bcUL, 0x0000UL, 0x01f7UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x01c6UL, 0x0000UL, 0x01c4UL, 0x01c9UL, 0x0000UL, 0x01c7UL, 0x01ccUL, 0x0000UL, 0x01caUL, 
    0x01ceUL, 0x01cdUL, 0x01d0UL, 0x01cfUL, 0x01d2UL, 0x01d1UL, 0x01d4UL, 0x01d3UL, 0x01d6UL, 
    0x01d5UL, 0x01d8UL, 0x01d7UL, 0x01daUL, 0x01d9UL, 0x01dcUL, 0x01dbUL, 0x018eUL, 0x01dfUL, 
    0x01deUL, 0x01e1UL, 0x01e0UL, 0x01e3UL, 0x01e2UL, 0x01e5UL, 0x01e4UL, 0x01e7UL, 0x01e6UL, 
    0x01e9UL, 0x01e8UL, 0x01ebUL, 0x01eaUL, 0x01edUL, 0x01ecUL, 0x01efUL, 0x01eeUL, 
    0x10000adUL, 0x01f3UL, 0x0000UL, 0x01f1UL, 0x01f5UL, 0x01f4UL, 0x0195UL, 0x01bfUL, 
    0x01f9UL, 0x01f8UL, 0x01fbUL, 0x01faUL, 0x01fdUL, 0x01fcUL, 0x01ffUL, 0x01feUL
  },
  { /* page 2, index 2 */
    0x0201UL, 0x0200UL, 0x0203UL, 0x0202UL, 0x0205UL, 0x0204UL, 0x0207UL, 0x0206UL, 0x0209UL, 
    0x0208UL, 0x020bUL, 0x020aUL, 0x020dUL, 0x020cUL, 0x020fUL, 0x020eUL, 0x0211UL, 0x0210UL, 
    0x0213UL, 0x0212UL, 0x0215UL, 0x0214UL, 0x0217UL, 0x0216UL, 0x0219UL, 0x0218UL, 0x021bUL, 
    0x021aUL, 0x021dUL, 0x021cUL, 0x021fUL, 0x021eUL, 0x019eUL, 0x0000UL, 0x0223UL, 0x0222UL, 
    0x0225UL, 0x0224UL, 0x0227UL, 0x0226UL, 0x0229UL, 0x0228UL, 0x022bUL, 0x022aUL, 0x022dUL, 
    0x022cUL, 0x022fUL, 0x022eUL, 0x0231UL, 0x0230UL, 0x0233UL, 0x0232UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2c65UL, 0x023cUL, 0x023bUL, 0x019aUL, 0x2c66UL, 
    0x2c7eUL, 0x2c7fUL, 0x0242UL, 0x0241UL, 0x0180UL, 0x0289UL, 0x028cUL, 0x0247UL, 0x0246UL, 
    0x0249UL, 0x0248UL, 0x024bUL, 0x024aUL, 0x024dUL, 0x024cUL, 0x024fUL, 0x024eUL, 0x2c6fUL, 
    0x2c6dUL, 0x2c70UL, 0x0181UL, 0x0186UL, 0x0000UL, 0x0189UL, 0x018aUL, 0x0000UL, 0x018fUL, 
    0x0000UL, 0x0190UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0193UL, 0x0000UL, 0x0000UL, 
    0x0194UL, 0x0000UL, 0xa78dUL, 0xa7aaUL, 0x0000UL, 0x0197UL, 0x0196UL, 0x0000UL, 0x2c62UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x019cUL, 0x0000UL, 0x2c6eUL, 0x019dUL, 0x0000UL, 0x0000UL, 
    0x019fUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2c64UL, 
    0x0000UL, 0x0000UL, 0x01a6UL, 0x0000UL, 0x0000UL, 0x01a9UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x01aeUL, 0x0244UL, 0x01b1UL, 0x01b2UL, 0x0245UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x01b7UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 3, index 3 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0371UL, 0x0370UL, 0x0373UL, 0x0372UL, 0x0000UL, 
    0x0000UL, 0x0377UL, 0x0376UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x03fdUL, 0x03feUL, 0x03ffUL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x03acUL, 
    0x0000UL, 0x03adUL, 0x03aeUL, 0x03afUL, 0x0000UL, 0x03ccUL, 0x0000UL, 0x03cdUL, 0x03ceUL, 
    0x100008fUL, 0x03b1UL, 0x03b2UL, 0x03b3UL, 0x03b4UL, 0x03b5UL, 0x03b6UL, 0x03b7UL, 
    0x03b8UL, 0x03b9UL, 0x03baUL, 0x03bbUL, 0x03bcUL, 0x03bdUL, 0x03beUL, 0x03bfUL, 0x03c0UL, 
    0x03c1UL, 0x0000UL, 0x03c3UL, 0x03c4UL, 0x03c5UL, 0x03c6UL, 0x03c7UL, 0x03c8UL, 0x03c9UL, 
    0x03caUL, 0x03cbUL, 0x0386UL, 0x0388UL, 0x0389UL, 0x038aUL, 0x100009eUL, 0x0391UL, 
    0x0392UL, 0x0393UL, 0x0394UL, 0x0395UL, 0x0396UL, 0x0397UL, 0x0398UL, 0x0399UL, 0x039aUL, 
    0x039bUL, 0x039cUL, 0x039dUL, 0x039eUL, 0x039fUL, 0x03a0UL, 0x03a1UL, 0x03a3UL, 0x03a3UL, 
    0x03a4UL, 0x03a5UL, 0x03a6UL, 0x03a7UL, 0x03a8UL, 0x03a9UL, 0x03aaUL, 0x03abUL, 0x038cUL, 
    0x038eUL, 0x038fUL, 0x03d7UL, 0x0392UL, 0x0398UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x03a6UL, 
    0x03a0UL, 0x03cfUL, 0x03d9UL, 0x03d8UL, 0x03dbUL, 0x03daUL, 0x03ddUL, 0x03dcUL, 0x03dfUL, 
    0x03deUL, 0x03e1UL, 0x03e0UL, 0x03e3UL, 0x03e2UL, 0x03e5UL, 0x03e4UL, 0x03e7UL, 0x03e6UL, 
    0x03e9UL, 0x03e8UL, 0x03ebUL, 0x03eaUL, 0x03edUL, 0x03ecUL, 0x03efUL, 0x03eeUL, 0x039aUL, 
    0x03a1UL, 0x03f9UL, 0x0000UL, 0x03b8UL, 0x0395UL, 0x0000UL, 0x03f8UL, 0x03f7UL, 0x03f2UL, 
    0x03fbUL, 0x03faUL, 0x0000UL, 0x037bUL, 0x037cUL, 0x037dUL
  },
  { /* page 4, index 4 */
    0x0450UL, 0x0451UL, 0x0452UL, 0x0453UL, 0x0454UL, 0x0455UL, 0x0456UL, 0x0457UL, 0x0458UL, 
    0x0459UL, 0x045aUL, 0x045bUL, 0x045cUL, 0x045dUL, 0x045eUL, 0x045fUL, 0x0430UL, 0x0431UL, 
    0x0432UL, 0x0433UL, 0x0434UL, 0x0435UL, 0x0436UL, 0x0437UL, 0x0438UL, 0x0439UL, 0x043aUL, 
    0x043bUL, 0x043cUL, 0x043dUL, 0x043eUL, 0x043fUL, 0x0440UL, 0x0441UL, 0x0442UL, 0x0443UL, 
    0x0444UL, 0x0445UL, 0x0446UL, 0x0447UL, 0x0448UL, 0x0449UL, 0x044aUL, 0x044bUL, 0x044cUL, 
    0x044dUL, 0x044eUL, 0x044fUL, 0x0410UL, 0x0411UL, 0x0412UL, 0x0413UL, 0x0414UL, 0x0415UL, 
    0x0416UL, 0x0417UL, 0x0418UL, 0x0419UL, 0x041aUL, 0x041bUL, 0x041cUL, 0x041dUL, 0x041eUL, 
    0x041fUL, 0x0420UL, 0x0421UL, 0x0422UL, 0x0423UL, 0x0424UL, 0x0425UL, 0x0426UL, 0x0427UL, 
    0x0428UL, 0x0429UL, 0x042aUL, 0x042bUL, 0x042cUL, 0x042dUL, 0x042eUL, 0x042fUL, 0x0400UL, 
    0x0401UL, 0x0402UL, 0x0403UL, 0x0404UL, 0x0405UL, 0x0406UL, 0x0407UL, 0x0408UL, 0x0409UL, 
    0x040aUL, 0x040bUL, 0x040cUL, 0x040dUL, 0x040eUL, 0x040fUL, 0x0461UL, 0x0460UL, 0x0463UL, 
    0x0462UL, 0x0465UL, 0x0464UL, 0x0467UL, 0x0466UL, 0x0469UL, 0x0468UL, 0x046bUL, 0x046aUL, 
    0x046dUL, 0x046cUL, 0x046fUL, 0x046eUL, 0x0471UL, 0x0470UL, 0x0473UL, 0x0472UL, 0x0475UL, 
    0x0474UL, 0x0477UL, 0x0476UL, 0x0479UL, 0x0478UL, 0x047bUL, 0x047aUL, 0x047dUL, 0x047cUL, 
    0x047fUL, 0x047eUL, 0x0481UL, 0x0480UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x048bUL, 0x048aUL, 0x048dUL, 0x048cUL, 0x048fUL, 0x048eUL, 
    0x0491UL, 0x0490UL, 0x0493UL, 0x0492UL, 0x0495UL, 0x0494UL, 0x0497UL, 0x0496UL, 0x0499UL, 
    0x0498UL, 0x049bUL, 0x049aUL, 0x049dUL, 0x049cUL, 0x049fUL, 0x049eUL, 0x04a1UL, 0x04a0UL, 
    0x04a3UL, 0x04a2UL, 0x04a5UL, 0x04a4UL, 0x04a7UL, 0x04a6UL, 0x04a9UL, 0x04a8UL, 0x04abUL, 
    0x04aaUL, 0x04adUL, 0x04acUL, 0x04afUL, 0x04aeUL, 0x04b1UL, 0x04b0UL, 0x04b3UL, 0x04b2UL, 
    0x04b5UL, 0x04b4UL, 0x04b7UL, 0x04b6UL, 0x04b9UL, 0x04b8UL, 0x04bbUL, 0x04baUL, 0x04bdUL, 
    0x04bcUL, 0x04bfUL, 0x04beUL, 0x04cfUL, 0x04c2UL, 0x04c1UL, 0x04c4UL, 0x04c3UL, 0x04c6UL, 
    0x04c5UL, 0x04c8UL, 0x04c7UL, 0x04caUL, 0x04c9UL, 0x04ccUL, 0x04cbUL, 0x04ceUL, 0x04cdUL, 
    0x04c0UL, 0x04d1UL, 0x04d0UL, 0x04d3UL, 0x04d2UL, 0x04d5UL, 0x04d4UL, 0x04d7UL, 0x04d6UL, 
    0x04d9UL, 0x04d8UL, 0x04dbUL, 0x04daUL, 0x04ddUL, 0x04dcUL, 0x04dfUL, 0x04deUL, 0x04e1UL, 
    0x04e0UL, 0x04e3UL, 0x04e2UL, 0x04e5UL, 0x04e4UL, 0x04e7UL, 0x04e6UL, 0x04e9UL, 0x04e8UL, 
    0x04ebUL, 0x04eaUL, 0x04edUL, 0x04ecUL, 0x04efUL, 0x04eeUL, 0x04f1UL, 0x04f0UL, 0x04f3UL, 
    0x04f2UL, 0x04f5UL, 0x04f4UL, 0x04f7UL, 0x04f6UL, 0x04f9UL, 0x04f8UL, 0x04fbUL, 0x04faUL, 
    0x04fdUL, 0x04fcUL, 0x04ffUL, 0x04feUL
  },
  { /* page 5, index 5 */
    0x0501UL, 0x0500UL, 0x0503UL, 0x0502UL, 0x0505UL, 0x0504UL, 0x0507UL, 0x0506UL, 0x0509UL, 
    0x0508UL, 0x050bUL, 0x050aUL, 0x050dUL, 0x050cUL, 0x050fUL, 0x050eUL, 0x0511UL, 0x0510UL, 
    0x0513UL, 0x0512UL, 0x0515UL, 0x0514UL, 0x0517UL, 0x0516UL, 0x0519UL, 0x0518UL, 0x051bUL, 
    0x051aUL, 0x051dUL, 0x051cUL, 0x051fUL, 0x051eUL, 0x0521UL, 0x0520UL, 0x0523UL, 0x0522UL, 
    0x0525UL, 0x0524UL, 0x0527UL, 0x0526UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0561UL, 0x0562UL, 0x0563UL, 0x0564UL, 0x0565UL, 
    0x0566UL, 0x0567UL, 0x0568UL, 0x0569UL, 0x056aUL, 0x056bUL, 0x056cUL, 0x056dUL, 0x056eUL, 
    0x056fUL, 0x0570UL, 0x0571UL, 0x0572UL, 0x0573UL, 0x0574UL, 0x0575UL, 0x0576UL, 0x0577UL, 
    0x0578UL, 0x0579UL, 0x057aUL, 0x057bUL, 0x057cUL, 0x057dUL, 0x057eUL, 0x057fUL, 0x0580UL, 
    0x0581UL, 0x0582UL, 0x0583UL, 0x0584UL, 0x0585UL, 0x0586UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0531UL, 0x0532UL, 
    0x0533UL, 0x0534UL, 0x0535UL, 0x0536UL, 0x0537UL, 0x0538UL, 0x0539UL, 0x053aUL, 0x053bUL, 
    0x053cUL, 0x053dUL, 0x053eUL, 0x053fUL, 0x0540UL, 0x0541UL, 0x0542UL, 0x0543UL, 0x0544UL, 
    0x0545UL, 0x0546UL, 0x0547UL, 0x0548UL, 0x0549UL, 0x054aUL, 0x054bUL, 0x054cUL, 0x054dUL, 
    0x054eUL, 0x054fUL, 0x0550UL, 0x0551UL, 0x0552UL, 0x0553UL, 0x0554UL, 0x0555UL, 0x0556UL, 
    0x1000044UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 6, index 6 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 
    0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 
    0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 7, index 7 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 9, index 8 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 10, index 9 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 11, index 10 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 12, index 11 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 13, index 12 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 14, index 13 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 15, index 14 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 16, index 15 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 
    0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2d00UL, 0x2d01UL, 
    0x2d02UL, 0x2d03UL, 0x2d04UL, 0x2d05UL, 0x2d06UL, 0x2d07UL, 0x2d08UL, 0x2d09UL, 0x2d0aUL, 
    0x2d0bUL, 0x2d0cUL, 0x2d0dUL, 0x2d0eUL, 0x2d0fUL, 0x2d10UL, 0x2d11UL, 0x2d12UL, 0x2d13UL, 
    0x2d14UL, 0x2d15UL, 0x2d16UL, 0x2d17UL, 0x2d18UL, 0x2d19UL, 0x2d1aUL, 0x2d1bUL, 0x2d1cUL, 
    0x2d1dUL, 0x2d1eUL, 0x2d1fUL, 0x2d20UL, 0x2d21UL, 0x2d22UL, 0x2d23UL, 0x2d24UL, 0x2d25UL, 
    0x0000UL, 0x2d27UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2d2dUL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 23, index 16 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 24, index 17 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 
    0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 25, index 18 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 
    0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 26, index 19 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 
    0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 
    0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 27, index 20 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 28, index 21 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 29, index 22 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xa77dUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2c63UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 30, index 23 */
    0x1e01UL, 0x1e00UL, 0x1e03UL, 0x1e02UL, 0x1e05UL, 0x1e04UL, 0x1e07UL, 0x1e06UL, 0x1e09UL, 
    0x1e08UL, 0x1e0bUL, 0x1e0aUL, 0x1e0dUL, 0x1e0cUL, 0x1e0fUL, 0x1e0eUL, 0x1e11UL, 0x1e10UL, 
    0x1e13UL, 0x1e12UL, 0x1e15UL, 0x1e14UL, 0x1e17UL, 0x1e16UL, 0x1e19UL, 0x1e18UL, 0x1e1bUL, 
    0x1e1aUL, 0x1e1dUL, 0x1e1cUL, 0x1e1fUL, 0x1e1eUL, 0x1e21UL, 0x1e20UL, 0x1e23UL, 0x1e22UL, 
    0x1e25UL, 0x1e24UL, 0x1e27UL, 0x1e26UL, 0x1e29UL, 0x1e28UL, 0x1e2bUL, 0x1e2aUL, 0x1e2dUL, 
    0x1e2cUL, 0x1e2fUL, 0x1e2eUL, 0x1e31UL, 0x1e30UL, 0x1e33UL, 0x1e32UL, 0x1e35UL, 0x1e34UL, 
    0x1e37UL, 0x1e36UL, 0x1e39UL, 0x1e38UL, 0x1e3bUL, 0x1e3aUL, 0x1e3dUL, 0x1e3cUL, 0x1e3fUL, 
    0x1e3eUL, 0x1e41UL, 0x1e40UL, 0x1e43UL, 0x1e42UL, 0x1e45UL, 0x1e44UL, 0x1e47UL, 0x1e46UL, 
    0x1e49UL, 0x1e48UL, 0x1e4bUL, 0x1e4aUL, 0x1e4dUL, 0x1e4cUL, 0x1e4fUL, 0x1e4eUL, 0x1e51UL, 
    0x1e50UL, 0x1e53UL, 0x1e52UL, 0x1e55UL, 0x1e54UL, 0x1e57UL, 0x1e56UL, 0x1e59UL, 0x1e58UL, 
    0x1e5bUL, 0x1e5aUL, 0x1e5dUL, 0x1e5cUL, 0x1e5fUL, 0x1e5eUL, 0x1e61UL, 0x1e60UL, 0x1e63UL, 
    0x1e62UL, 0x1e65UL, 0x1e64UL, 0x1e67UL, 0x1e66UL, 0x1e69UL, 0x1e68UL, 0x1e6bUL, 0x1e6aUL, 
    0x1e6dUL, 0x1e6cUL, 0x1e6fUL, 0x1e6eUL, 0x1e71UL, 0x1e70UL, 0x1e73UL, 0x1e72UL, 0x1e75UL, 
    0x1e74UL, 0x1e77UL, 0x1e76UL, 0x1e79UL, 0x1e78UL, 0x1e7bUL, 0x1e7aUL, 0x1e7dUL, 0x1e7cUL, 
    0x1e7fUL, 0x1e7eUL, 0x1e81UL, 0x1e80UL, 0x1e83UL, 0x1e82UL, 0x1e85UL, 0x1e84UL, 0x1e87UL, 
    0x1e86UL, 0x1e89UL, 0x1e88UL, 0x1e8bUL, 0x1e8aUL, 0x1e8dUL, 0x1e8cUL, 0x1e8fUL, 0x1e8eUL, 
    0x1e91UL, 0x1e90UL, 0x1e93UL, 0x1e92UL, 0x1e95UL, 0x1e94UL, 0x10000b6UL, 0x10000bfUL, 
    0x10000c8UL, 0x10000d1UL, 0x10000daUL, 0x1e60UL, 0x0000UL, 0x0000UL, 0x00dfUL, 0x0000UL, 
    0x1ea1UL, 0x1ea0UL, 0x1ea3UL, 0x1ea2UL, 0x1ea5UL, 0x1ea4UL, 0x1ea7UL, 0x1ea6UL, 0x1ea9UL, 
    0x1ea8UL, 0x1eabUL, 0x1eaaUL, 0x1eadUL, 0x1eacUL, 0x1eafUL, 0x1eaeUL, 0x1eb1UL, 0x1eb0UL, 
    0x1eb3UL, 0x1eb2UL, 0x1eb5UL, 0x1eb4UL, 0x1eb7UL, 0x1eb6UL, 0x1eb9UL, 0x1eb8UL, 0x1ebbUL, 
    0x1ebaUL, 0x1ebdUL, 0x1ebcUL, 0x1ebfUL, 0x1ebeUL, 0x1ec1UL, 0x1ec0UL, 0x1ec3UL, 0x1ec2UL, 
    0x1ec5UL, 0x1ec4UL, 0x1ec7UL, 0x1ec6UL, 0x1ec9UL, 0x1ec8UL, 0x1ecbUL, 0x1ecaUL, 0x1ecdUL, 
    0x1eccUL, 0x1ecfUL, 0x1eceUL, 0x1ed1UL, 0x1ed0UL, 0x1ed3UL, 0x1ed2UL, 0x1ed5UL, 0x1ed4UL, 
    0x1ed7UL, 0x1ed6UL, 0x1ed9UL, 0x1ed8UL, 0x1edbUL, 0x1edaUL, 0x1eddUL, 0x1edcUL, 0x1edfUL, 
    0x1edeUL, 0x1ee1UL, 0x1ee0UL, 0x1ee3UL, 0x1ee2UL, 0x1ee5UL, 0x1ee4UL, 0x1ee7UL, 0x1ee6UL, 
    0x1ee9UL, 0x1ee8UL, 0x1eebUL, 0x1eeaUL, 0x1eedUL, 0x1eecUL, 0x1eefUL, 0x1eeeUL, 0x1ef1UL, 
    0x1ef0UL, 0x1ef3UL, 0x1ef2UL, 0x1ef5UL, 0x1ef4UL, 0x1ef7UL, 0x1ef6UL, 0x1ef9UL, 0x1ef8UL, 
    0x1efbUL, 0x1efaUL, 0x1efdUL, 0x1efcUL, 0x1effUL, 0x1efeUL
  },
  { /* page 31, index 24 */
    0x1f08UL, 0x1f09UL, 0x1f0aUL, 0x1f0bUL, 0x1f0cUL, 0x1f0dUL, 0x1f0eUL, 0x1f0fUL, 0x1f00UL, 
    0x1f01UL, 0x1f02UL, 0x1f03UL, 0x1f04UL, 0x1f05UL, 0x1f06UL, 0x1f07UL, 0x1f18UL, 0x1f19UL, 
    0x1f1aUL, 0x1f1bUL, 0x1f1cUL, 0x1f1dUL, 0x0000UL, 0x0000UL, 0x1f10UL, 0x1f11UL, 0x1f12UL, 
    0x1f13UL, 0x1f14UL, 0x1f15UL, 0x0000UL, 0x0000UL, 0x1f28UL, 0x1f29UL, 0x1f2aUL, 0x1f2bUL, 
    0x1f2cUL, 0x1f2dUL, 0x1f2eUL, 0x1f2fUL, 0x1f20UL, 0x1f21UL, 0x1f22UL, 0x1f23UL, 0x1f24UL, 
    0x1f25UL, 0x1f26UL, 0x1f27UL, 0x1f38UL, 0x1f39UL, 0x1f3aUL, 0x1f3bUL, 0x1f3cUL, 0x1f3dUL, 
    0x1f3eUL, 0x1f3fUL, 0x1f30UL, 0x1f31UL, 0x1f32UL, 0x1f33UL, 0x1f34UL, 0x1f35UL, 0x1f36UL, 
    0x1f37UL, 0x1f48UL, 0x1f49UL, 0x1f4aUL, 0x1f4bUL, 0x1f4cUL, 0x1f4dUL, 0x0000UL, 0x0000UL, 
    0x1f40UL, 0x1f41UL, 0x1f42UL, 0x1f43UL, 0x1f44UL, 0x1f45UL, 0x0000UL, 0x0000UL, 
    0x10000e3UL, 0x1f59UL, 0x10000eeUL, 0x1f5bUL, 0x10000fdUL, 0x1f5dUL, 0x100010cUL, 
    0x1f5fUL, 0x0000UL, 0x1f51UL, 0x0000UL, 0x1f53UL, 0x0000UL, 0x1f55UL, 0x0000UL, 0x1f57UL, 
    0x1f68UL, 0x1f69UL, 0x1f6aUL, 0x1f6bUL, 0x1f6cUL, 0x1f6dUL, 0x1f6eUL, 0x1f6fUL, 0x1f60UL, 
    0x1f61UL, 0x1f62UL, 0x1f63UL, 0x1f64UL, 0x1f65UL, 0x1f66UL, 0x1f67UL, 0x1fbaUL, 0x1fbbUL, 
    0x1fc8UL, 0x1fc9UL, 0x1fcaUL, 0x1fcbUL, 0x1fdaUL, 0x1fdbUL, 0x1ff8UL, 0x1ff9UL, 0x1feaUL, 
    0x1febUL, 0x1ffaUL, 0x1ffbUL, 0x0000UL, 0x0000UL, 0x10001b7UL, 0x10001c4UL, 0x10001d1UL, 
    0x10001deUL, 0x10001ebUL, 0x10001f8UL, 0x1000205UL, 0x1000212UL, 0x100021fUL, 
    0x1000229UL, 0x1000233UL, 0x100023dUL, 0x1000247UL, 0x1000251UL, 0x100025bUL, 
    0x1000265UL, 0x100026fUL, 0x100027cUL, 0x1000289UL, 0x1000296UL, 0x10002a3UL, 
    0x10002b0UL, 0x10002bdUL, 0x10002caUL, 0x10002d7UL, 0x10002e1UL, 0x10002ebUL, 
    0x10002f5UL, 0x10002ffUL, 0x1000309UL, 0x1000313UL, 0x100031dUL, 0x1000327UL, 
    0x1000334UL, 0x1000341UL, 0x100034eUL, 0x100035bUL, 0x1000368UL, 0x1000375UL, 
    0x1000382UL, 0x100038fUL, 0x1000399UL, 0x10003a3UL, 0x10003adUL, 0x10003b7UL, 
    0x10003c1UL, 0x10003cbUL, 0x10003d5UL, 0x1fb8UL, 0x1fb9UL, 0x100041eUL, 0x10003dfUL, 
    0x100042bUL, 0x0000UL, 0x100011bUL, 0x1000466UL, 0x1fb0UL, 0x1fb1UL, 0x1f70UL, 0x1f71UL, 
    0x10003ebUL, 0x0000UL, 0x0399UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x1000436UL, 0x10003f4UL, 
    0x1000443UL, 0x0000UL, 0x1000126UL, 0x1000475UL, 0x1f72UL, 0x1f73UL, 0x1f74UL, 0x1f75UL, 
    0x1000400UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x1fd8UL, 0x1fd9UL, 0x1000131UL, 0x1000140UL, 
    0x0000UL, 0x0000UL, 0x100014fUL, 0x100015aUL, 0x1fd0UL, 0x1fd1UL, 0x1f76UL, 0x1f77UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x1fe8UL, 0x1fe9UL, 0x1000169UL, 0x1000178UL, 
    0x1000187UL, 0x1fecUL, 0x1000192UL, 0x100019dUL, 0x1fe0UL, 0x1fe1UL, 0x1f7aUL, 0x1f7bUL, 
    0x1fe5UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x100044eUL, 0x1000409UL, 
    0x100045bUL, 0x0000UL, 0x10001acUL, 0x1000484UL, 0x1f78UL, 0x1f79UL, 0x1f7cUL, 0x1f7dUL, 
    0x1000415UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 33, index 25 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x03c9UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x006bUL, 0x00e5UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x214eUL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2132UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2184UL, 0x2183UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 44, index 26 */
    0x2c30UL, 0x2c31UL, 0x2c32UL, 0x2c33UL, 0x2c34UL, 0x2c35UL, 0x2c36UL, 0x2c37UL, 0x2c38UL, 
    0x2c39UL, 0x2c3aUL, 0x2c3bUL, 0x2c3cUL, 0x2c3dUL, 0x2c3eUL, 0x2c3fUL, 0x2c40UL, 0x2c41UL, 
    0x2c42UL, 0x2c43UL, 0x2c44UL, 0x2c45UL, 0x2c46UL, 0x2c47UL, 0x2c48UL, 0x2c49UL, 0x2c4aUL, 
    0x2c4bUL, 0x2c4cUL, 0x2c4dUL, 0x2c4eUL, 0x2c4fUL, 0x2c50UL, 0x2c51UL, 0x2c52UL, 0x2c53UL, 
    0x2c54UL, 0x2c55UL, 0x2c56UL, 0x2c57UL, 0x2c58UL, 0x2c59UL, 0x2c5aUL, 0x2c5bUL, 0x2c5cUL, 
    0x2c5dUL, 0x2c5eUL, 0x0000UL, 0x2c00UL, 0x2c01UL, 0x2c02UL, 0x2c03UL, 0x2c04UL, 0x2c05UL, 
    0x2c06UL, 0x2c07UL, 0x2c08UL, 0x2c09UL, 0x2c0aUL, 0x2c0bUL, 0x2c0cUL, 0x2c0dUL, 0x2c0eUL, 
    0x2c0fUL, 0x2c10UL, 0x2c11UL, 0x2c12UL, 0x2c13UL, 0x2c14UL, 0x2c15UL, 0x2c16UL, 0x2c17UL, 
    0x2c18UL, 0x2c19UL, 0x2c1aUL, 0x2c1bUL, 0x2c1cUL, 0x2c1dUL, 0x2c1eUL, 0x2c1fUL, 0x2c20UL, 
    0x2c21UL, 0x2c22UL, 0x2c23UL, 0x2c24UL, 0x2c25UL, 0x2c26UL, 0x2c27UL, 0x2c28UL, 0x2c29UL, 
    0x2c2aUL, 0x2c2bUL, 0x2c2cUL, 0x2c2dUL, 0x2c2eUL, 0x0000UL, 0x2c61UL, 0x2c60UL, 0x026bUL, 
    0x1d7dUL, 0x027dUL, 0x023aUL, 0x023eUL, 0x2c68UL, 0x2c67UL, 0x2c6aUL, 0x2c69UL, 0x2c6cUL, 
    0x2c6bUL, 0x0251UL, 0x0271UL, 0x0250UL, 0x0252UL, 0x0000UL, 0x2c73UL, 0x2c72UL, 0x0000UL, 
    0x2c76UL, 0x2c75UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x023fUL, 0x0240UL, 0x2c81UL, 0x2c80UL, 0x2c83UL, 0x2c82UL, 0x2c85UL, 0x2c84UL, 0x2c87UL, 
    0x2c86UL, 0x2c89UL, 0x2c88UL, 0x2c8bUL, 0x2c8aUL, 0x2c8dUL, 0x2c8cUL, 0x2c8fUL, 0x2c8eUL, 
    0x2c91UL, 0x2c90UL, 0x2c93UL, 0x2c92UL, 0x2c95UL, 0x2c94UL, 0x2c97UL, 0x2c96UL, 0x2c99UL, 
    0x2c98UL, 0x2c9bUL, 0x2c9aUL, 0x2c9dUL, 0x2c9cUL, 0x2c9fUL, 0x2c9eUL, 0x2ca1UL, 0x2ca0UL, 
    0x2ca3UL, 0x2ca2UL, 0x2ca5UL, 0x2ca4UL, 0x2ca7UL, 0x2ca6UL, 0x2ca9UL, 0x2ca8UL, 0x2cabUL, 
    0x2caaUL, 0x2cadUL, 0x2cacUL, 0x2cafUL, 0x2caeUL, 0x2cb1UL, 0x2cb0UL, 0x2cb3UL, 0x2cb2UL, 
    0x2cb5UL, 0x2cb4UL, 0x2cb7UL, 0x2cb6UL, 0x2cb9UL, 0x2cb8UL, 0x2cbbUL, 0x2cbaUL, 0x2cbdUL, 
    0x2cbcUL, 0x2cbfUL, 0x2cbeUL, 0x2cc1UL, 0x2cc0UL, 0x2cc3UL, 0x2cc2UL, 0x2cc5UL, 0x2cc4UL, 
    0x2cc7UL, 0x2cc6UL, 0x2cc9UL, 0x2cc8UL, 0x2ccbUL, 0x2ccaUL, 0x2ccdUL, 0x2cccUL, 0x2ccfUL, 
    0x2cceUL, 0x2cd1UL, 0x2cd0UL, 0x2cd3UL, 0x2cd2UL, 0x2cd5UL, 0x2cd4UL, 0x2cd7UL, 0x2cd6UL, 
    0x2cd9UL, 0x2cd8UL, 0x2cdbUL, 0x2cdaUL, 0x2cddUL, 0x2cdcUL, 0x2cdfUL, 0x2cdeUL, 0x2ce1UL, 
    0x2ce0UL, 0x2ce3UL, 0x2ce2UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x2cecUL, 0x2cebUL, 0x2ceeUL, 0x2cedUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x2cf3UL, 
    0x2cf2UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 45, index 27 */
    0x10a0UL, 0x10a1UL, 0x10a2UL, 0x10a3UL, 0x10a4UL, 0x10a5UL, 0x10a6UL, 0x10a7UL, 0x10a8UL, 
    0x10a9UL, 0x10aaUL, 0x10abUL, 0x10acUL, 0x10adUL, 0x10aeUL, 0x10afUL, 0x10b0UL, 0x10b1UL, 
    0x10b2UL, 0x10b3UL, 0x10b4UL, 0x10b5UL, 0x10b6UL, 0x10b7UL, 0x10b8UL, 0x10b9UL, 0x10baUL, 
    0x10bbUL, 0x10bcUL, 0x10bdUL, 0x10beUL, 0x10bfUL, 0x10c0UL, 0x10c1UL, 0x10c2UL, 0x10c3UL, 
    0x10c4UL, 0x10c5UL, 0x0000UL, 0x10c7UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x10cdUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 166, index 28 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 
    0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0xa641UL, 0xa640UL, 0xa643UL, 0xa642UL, 0xa645UL, 0xa644UL, 0xa647UL, 0xa646UL, 
    0xa649UL, 0xa648UL, 0xa64bUL, 0xa64aUL, 0xa64dUL, 0xa64cUL, 0xa64fUL, 0xa64eUL, 0xa651UL, 
    0xa650UL, 0xa653UL, 0xa652UL, 0xa655UL, 0xa654UL, 0xa657UL, 0xa656UL, 0xa659UL, 0xa658UL, 
    0xa65bUL, 0xa65aUL, 0xa65dUL, 0xa65cUL, 0xa65fUL, 0xa65eUL, 0xa661UL, 0xa660UL, 0xa663UL, 
    0xa662UL, 0xa665UL, 0xa664UL, 0xa667UL, 0xa666UL, 0xa669UL, 0xa668UL, 0xa66bUL, 0xa66aUL, 
    0xa66dUL, 0xa66cUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0xa681UL, 0xa680UL, 0xa683UL, 0xa682UL, 0xa685UL, 0xa684UL, 0xa687UL, 
    0xa686UL, 0xa689UL, 0xa688UL, 0xa68bUL, 0xa68aUL, 0xa68dUL, 0xa68cUL, 0xa68fUL, 0xa68eUL, 
    0xa691UL, 0xa690UL, 0xa693UL, 0xa692UL, 0xa695UL, 0xa694UL, 0xa697UL, 0xa696UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 167, index 29 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xa723UL, 0xa722UL, 
    0xa725UL, 0xa724UL, 0xa727UL, 0xa726UL, 0xa729UL, 0xa728UL, 0xa72bUL, 0xa72aUL, 0xa72dUL, 
    0xa72cUL, 0xa72fUL, 0xa72eUL, 0x0000UL, 0x0000UL, 0xa733UL, 0xa732UL, 0xa735UL, 0xa734UL, 
    0xa737UL, 0xa736UL, 0xa739UL, 0xa738UL, 0xa73bUL, 0xa73aUL, 0xa73dUL, 0xa73cUL, 0xa73fUL, 
    0xa73eUL, 0xa741UL, 0xa740UL, 0xa743UL, 0xa742UL, 0xa745UL, 0xa744UL, 0xa747UL, 0xa746UL, 
    0xa749UL, 0xa748UL, 0xa74bUL, 0xa74aUL, 0xa74dUL, 0xa74cUL, 0xa74fUL, 0xa74eUL, 0xa751UL, 
    0xa750UL, 0xa753UL, 0xa752UL, 0xa755UL, 0xa754UL, 0xa757UL, 0xa756UL, 0xa759UL, 0xa758UL, 
    0xa75bUL, 0xa75aUL, 0xa75dUL, 0xa75cUL, 0xa75fUL, 0xa75eUL, 0xa761UL, 0xa760UL, 0xa763UL, 
    0xa762UL, 0xa765UL, 0xa764UL, 0xa767UL, 0xa766UL, 0xa769UL, 0xa768UL, 0xa76bUL, 0xa76aUL, 
    0xa76dUL, 0xa76cUL, 0xa76fUL, 0xa76eUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xa77aUL, 0xa779UL, 0xa77cUL, 0xa77bUL, 0x1d79UL, 
    0xa77fUL, 0xa77eUL, 0xa781UL, 0xa780UL, 0xa783UL, 0xa782UL, 0xa785UL, 0xa784UL, 0xa787UL, 
    0xa786UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xa78cUL, 0xa78bUL, 0x0265UL, 0x0000UL, 0x0000UL, 
    0xa791UL, 0xa790UL, 0xa793UL, 0xa792UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xa7a1UL, 0xa7a0UL, 
    0xa7a3UL, 0xa7a2UL, 0xa7a5UL, 0xa7a4UL, 0xa7a7UL, 0xa7a6UL, 0xa7a9UL, 0xa7a8UL, 0x0266UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 168, index 30 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 169, index 31 */
    0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 
    0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 170, index 32 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 171, index 33 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 
    0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 251, index 34 */
    0x100000fUL, 0x1000016UL, 0x100001dUL, 0x1000024UL, 0x100002dUL, 0x1000036UL, 
    0x100003dUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x100004fUL, 0x100005aUL, 0x1000065UL, 
    0x1000070UL, 0x100007bUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL
  },
  { /* page 255, index 35 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 
    0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0xff41UL, 0xff42UL, 0xff43UL, 
    0xff44UL, 0xff45UL, 0xff46UL, 0xff47UL, 0xff48UL, 0xff49UL, 0xff4aUL, 0xff4bUL, 0xff4cUL, 
    0xff4dUL, 0xff4eUL, 0xff4fUL, 0xff50UL, 0xff51UL, 0xff52UL, 0xff53UL, 0xff54UL, 0xff55UL, 
    0xff56UL, 0xff57UL, 0xff58UL, 0xff59UL, 0xff5aUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0xff21UL, 0xff22UL, 0xff23UL, 0xff24UL, 0xff25UL, 0xff26UL, 0xff27UL, 
    0xff28UL, 0xff29UL, 0xff2aUL, 0xff2bUL, 0xff2cUL, 0xff2dUL, 0xff2eUL, 0xff2fUL, 0xff30UL, 
    0xff31UL, 0xff32UL, 0xff33UL, 0xff34UL, 0xff35UL, 0xff36UL, 0xff37UL, 0xff38UL, 0xff39UL, 
    0xff3aUL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 260, index 36 */
    0x10428UL, 0x10429UL, 0x1042aUL, 0x1042bUL, 0x1042cUL, 0x1042dUL, 0x1042eUL, 0x1042fUL, 
    0x10430UL, 0x10431UL, 0x10432UL, 0x10433UL, 0x10434UL, 0x10435UL, 0x10436UL, 0x10437UL, 
    0x10438UL, 0x10439UL, 0x1043aUL, 0x1043bUL, 0x1043cUL, 0x1043dUL, 0x1043eUL, 0x1043fUL, 
    0x10440UL, 0x10441UL, 0x10442UL, 0x10443UL, 0x10444UL, 0x10445UL, 0x10446UL, 0x10447UL, 
    0x10448UL, 0x10449UL, 0x1044aUL, 0x1044bUL, 0x1044cUL, 0x1044dUL, 0x1044eUL, 0x1044fUL, 
    0x10400UL, 0x10401UL, 0x10402UL, 0x10403UL, 0x10404UL, 0x10405UL, 0x10406UL, 0x10407UL, 
    0x10408UL, 0x10409UL, 0x1040aUL, 0x1040bUL, 0x1040cUL, 0x1040dUL, 0x1040eUL, 0x1040fUL, 
    0x10410UL, 0x10411UL, 0x10412UL, 0x10413UL, 0x10414UL, 0x10415UL, 0x10416UL, 0x10417UL, 
    0x10418UL, 0x10419UL, 0x1041aUL, 0x1041bUL, 0x1041cUL, 0x1041dUL, 0x1041eUL, 0x1041fUL, 
    0x10420UL, 0x10421UL, 0x10422UL, 0x10423UL, 0x10424UL, 0x10425UL, 0x10426UL, 0x10427UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 272, index 37 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 
    0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 273, index 38 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 
    0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 278, index 39 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL
  },
  { /* page 471, index 40 */
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 0x0000UL, 
    0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL, 
    0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 0x0008UL, 
    0x0009UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 0x0007UL, 
    0x0008UL, 0x0009UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 0x0006UL, 
    0x0007UL, 0x0008UL, 0x0009UL, 0x0000UL, 0x0001UL, 0x0002UL, 0x0003UL, 0x0004UL, 0x0005UL, 
    0x0006UL, 0x0007UL, 0x0008UL, 0x0009UL
  }
};

/* U+0000 through U+2FAFF */
static short const attr_table_part1[763] = {
  0 /* page 0 */,
  1 /* page 1 */,
  2 /* page 2 */,
  3 /* page 3 */,
  4 /* page 4 */,
  5 /* page 5 */,
  6 /* page 6 */,
  7 /* page 7 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  8 /* page 9 */,
  9 /* page 10 */,
  10 /* page 11 */,
  11 /* page 12 */,
  12 /* page 13 */,
  13 /* page 14 */,
  14 /* page 15 */,
  15 /* page 16 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  16 /* page 23 */,
  17 /* page 24 */,
  18 /* page 25 */,
  19 /* page 26 */,
  20 /* page 27 */,
  21 /* page 28 */,
  22 /* page 29 */,
  23 /* page 30 */,
  24 /* page 31 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  25 /* page 33 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  26 /* page 44 */,
  27 /* page 45 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  28 /* page 166 */,
  29 /* page 167 */,
  30 /* page 168 */,
  31 /* page 169 */,
  32 /* page 170 */,
  33 /* page 171 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  34 /* page 251 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  35 /* page 255 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  36 /* page 260 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  37 /* page 272 */,
  38 /* page 273 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  39 /* page 278 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  40 /* page 471 */,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX
};

/* U+E0000 through U+10FFFF */
static short const attr_table_part2[768] = {
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX,
  0x0000 + G_UNICODE_MAX_TABLE_INDEX
};

static h_unichar_t const title_table[][3] = {
  { 0x01c5UL, 0x01c4UL, 0x01c6 },
  { 0x01c8UL, 0x01c7UL, 0x01c9 },
  { 0x01cbUL, 0x01caUL, 0x01cc },
  { 0x01f2UL, 0x01f1UL, 0x01f3 },
  { 0x1f88UL, 0x0000UL, 0x1f80 },
  { 0x1f89UL, 0x0000UL, 0x1f81 },
  { 0x1f8aUL, 0x0000UL, 0x1f82 },
  { 0x1f8bUL, 0x0000UL, 0x1f83 },
  { 0x1f8cUL, 0x0000UL, 0x1f84 },
  { 0x1f8dUL, 0x0000UL, 0x1f85 },
  { 0x1f8eUL, 0x0000UL, 0x1f86 },
  { 0x1f8fUL, 0x0000UL, 0x1f87 },
  { 0x1f98UL, 0x0000UL, 0x1f90 },
  { 0x1f99UL, 0x0000UL, 0x1f91 },
  { 0x1f9aUL, 0x0000UL, 0x1f92 },
  { 0x1f9bUL, 0x0000UL, 0x1f93 },
  { 0x1f9cUL, 0x0000UL, 0x1f94 },
  { 0x1f9dUL, 0x0000UL, 0x1f95 },
  { 0x1f9eUL, 0x0000UL, 0x1f96 },
  { 0x1f9fUL, 0x0000UL, 0x1f97 },
  { 0x1fa8UL, 0x0000UL, 0x1fa0 },
  { 0x1fa9UL, 0x0000UL, 0x1fa1 },
  { 0x1faaUL, 0x0000UL, 0x1fa2 },
  { 0x1fabUL, 0x0000UL, 0x1fa3 },
  { 0x1facUL, 0x0000UL, 0x1fa4 },
  { 0x1fadUL, 0x0000UL, 0x1fa5 },
  { 0x1faeUL, 0x0000UL, 0x1fa6 },
  { 0x1fafUL, 0x0000UL, 0x1fa7 },
  { 0x1fbcUL, 0x0000UL, 0x1fb3 },
  { 0x1fccUL, 0x0000UL, 0x1fc3 },
  { 0x1ffcUL, 0x0000UL, 0x1ff3 }
};


/* Table of special cases for case conversion; each record contains
 * FirstUL, the best single character mapping to lowercase if LuUL, 
 * and to uppercase if LlUL, followed by the output mapping for the two cases 
 * other than the case of the codepointUL, in the order [Ll],[Lu],[Lt],
 * encoded in UTF-8UL, separated and terminated by a null character.
 */
static char const special_case_table[] = {
 "\x00\x53\x53\x00\x53\x73\0" /* offset 0 */
 "\x69\x69\xcc\x87\x00\xc4\xb0\0" /* offset 7 */
 "\x00\x46\x46\x00\x46\x66\0" /* offset 15 */
 "\x00\x46\x49\x00\x46\x69\0" /* offset 22 */
 "\x00\x46\x4c\x00\x46\x6c\0" /* offset 29 */
 "\x00\x46\x46\x49\x00\x46\x66\x69\0" /* offset 36 */
 "\x00\x46\x46\x4c\x00\x46\x66\x6c\0" /* offset 45 */
 "\x00\x53\x54\x00\x53\x74\0" /* offset 54 */
 "\x00\x53\x54\x00\x53\x74\0" /* offset 61 */
 "\x00\xd4\xb5\xd5\x92\x00\xd4\xb5\xd6\x82\0" /* offset 68 */
 "\x00\xd5\x84\xd5\x86\x00\xd5\x84\xd5\xb6\0" /* offset 79 */
 "\x00\xd5\x84\xd4\xb5\x00\xd5\x84\xd5\xa5\0" /* offset 90 */
 "\x00\xd5\x84\xd4\xbb\x00\xd5\x84\xd5\xab\0" /* offset 101 */
 "\x00\xd5\x8e\xd5\x86\x00\xd5\x8e\xd5\xb6\0" /* offset 112 */
 "\x00\xd5\x84\xd4\xbd\x00\xd5\x84\xd5\xad\0" /* offset 123 */
 "\x00\xca\xbc\x4e\x00\xca\xbc\x4e\0" /* offset 134 */
 "\x00\xce\x99\xcc\x88\xcc\x81\x00\xce\x99\xcc\x88\xcc\x81\0" /* offset 143 */
 "\x00\xce\xa5\xcc\x88\xcc\x81\x00\xce\xa5\xcc\x88\xcc\x81\0" /* offset 158 */
 "\x00\x4a\xcc\x8c\x00\x4a\xcc\x8c\0" /* offset 173 */
 "\x00\x48\xcc\xb1\x00\x48\xcc\xb1\0" /* offset 182 */
 "\x00\x54\xcc\x88\x00\x54\xcc\x88\0" /* offset 191 */
 "\x00\x57\xcc\x8a\x00\x57\xcc\x8a\0" /* offset 200 */
 "\x00\x59\xcc\x8a\x00\x59\xcc\x8a\0" /* offset 209 */
 "\x00\x41\xca\xbe\x00\x41\xca\xbe\0" /* offset 218 */
 "\x00\xce\xa5\xcc\x93\x00\xce\xa5\xcc\x93\0" /* offset 227 */
 "\x00\xce\xa5\xcc\x93\xcc\x80\x00\xce\xa5\xcc\x93\xcc\x80\0" /* offset 238 */
 "\x00\xce\xa5\xcc\x93\xcc\x81\x00\xce\xa5\xcc\x93\xcc\x81\0" /* offset 253 */
 "\x00\xce\xa5\xcc\x93\xcd\x82\x00\xce\xa5\xcc\x93\xcd\x82\0" /* offset 268 */
 "\x00\xce\x91\xcd\x82\x00\xce\x91\xcd\x82\0" /* offset 283 */
 "\x00\xce\x97\xcd\x82\x00\xce\x97\xcd\x82\0" /* offset 294 */
 "\x00\xce\x99\xcc\x88\xcc\x80\x00\xce\x99\xcc\x88\xcc\x80\0" /* offset 305 */
 "\x00\xce\x99\xcc\x88\xcc\x81\x00\xce\x99\xcc\x88\xcc\x81\0" /* offset 320 */
 "\x00\xce\x99\xcd\x82\x00\xce\x99\xcd\x82\0" /* offset 335 */
 "\x00\xce\x99\xcc\x88\xcd\x82\x00\xce\x99\xcc\x88\xcd\x82\0" /* offset 346 */
 "\x00\xce\xa5\xcc\x88\xcc\x80\x00\xce\xa5\xcc\x88\xcc\x80\0" /* offset 361 */
 "\x00\xce\xa5\xcc\x88\xcc\x81\x00\xce\xa5\xcc\x88\xcc\x81\0" /* offset 376 */
 "\x00\xce\xa1\xcc\x93\x00\xce\xa1\xcc\x93\0" /* offset 391 */
 "\x00\xce\xa5\xcd\x82\x00\xce\xa5\xcd\x82\0" /* offset 402 */
 "\x00\xce\xa5\xcc\x88\xcd\x82\x00\xce\xa5\xcc\x88\xcd\x82\0" /* offset 413 */
 "\x00\xce\xa9\xcd\x82\x00\xce\xa9\xcd\x82\0" /* offset 428 */
 "\xe1\xbe\x88\xe1\xbc\x88\xce\x99\x00\xe1\xbe\x88\0" /* offset 439 */
 "\xe1\xbe\x89\xe1\xbc\x89\xce\x99\x00\xe1\xbe\x89\0" /* offset 452 */
 "\xe1\xbe\x8a\xe1\xbc\x8a\xce\x99\x00\xe1\xbe\x8a\0" /* offset 465 */
 "\xe1\xbe\x8b\xe1\xbc\x8b\xce\x99\x00\xe1\xbe\x8b\0" /* offset 478 */
 "\xe1\xbe\x8c\xe1\xbc\x8c\xce\x99\x00\xe1\xbe\x8c\0" /* offset 491 */
 "\xe1\xbe\x8d\xe1\xbc\x8d\xce\x99\x00\xe1\xbe\x8d\0" /* offset 504 */
 "\xe1\xbe\x8e\xe1\xbc\x8e\xce\x99\x00\xe1\xbe\x8e\0" /* offset 517 */
 "\xe1\xbe\x8f\xe1\xbc\x8f\xce\x99\x00\xe1\xbe\x8f\0" /* offset 530 */
 "\xe1\xbe\x80\x00\xe1\xbc\x88\xce\x99\0" /* offset 543 */
 "\xe1\xbe\x81\x00\xe1\xbc\x89\xce\x99\0" /* offset 553 */
 "\xe1\xbe\x82\x00\xe1\xbc\x8a\xce\x99\0" /* offset 563 */
 "\xe1\xbe\x83\x00\xe1\xbc\x8b\xce\x99\0" /* offset 573 */
 "\xe1\xbe\x84\x00\xe1\xbc\x8c\xce\x99\0" /* offset 583 */
 "\xe1\xbe\x85\x00\xe1\xbc\x8d\xce\x99\0" /* offset 593 */
 "\xe1\xbe\x86\x00\xe1\xbc\x8e\xce\x99\0" /* offset 603 */
 "\xe1\xbe\x87\x00\xe1\xbc\x8f\xce\x99\0" /* offset 613 */
 "\xe1\xbe\x98\xe1\xbc\xa8\xce\x99\x00\xe1\xbe\x98\0" /* offset 623 */
 "\xe1\xbe\x99\xe1\xbc\xa9\xce\x99\x00\xe1\xbe\x99\0" /* offset 636 */
 "\xe1\xbe\x9a\xe1\xbc\xaa\xce\x99\x00\xe1\xbe\x9a\0" /* offset 649 */
 "\xe1\xbe\x9b\xe1\xbc\xab\xce\x99\x00\xe1\xbe\x9b\0" /* offset 662 */
 "\xe1\xbe\x9c\xe1\xbc\xac\xce\x99\x00\xe1\xbe\x9c\0" /* offset 675 */
 "\xe1\xbe\x9d\xe1\xbc\xad\xce\x99\x00\xe1\xbe\x9d\0" /* offset 688 */
 "\xe1\xbe\x9e\xe1\xbc\xae\xce\x99\x00\xe1\xbe\x9e\0" /* offset 701 */
 "\xe1\xbe\x9f\xe1\xbc\xaf\xce\x99\x00\xe1\xbe\x9f\0" /* offset 714 */
 "\xe1\xbe\x90\x00\xe1\xbc\xa8\xce\x99\0" /* offset 727 */
 "\xe1\xbe\x91\x00\xe1\xbc\xa9\xce\x99\0" /* offset 737 */
 "\xe1\xbe\x92\x00\xe1\xbc\xaa\xce\x99\0" /* offset 747 */
 "\xe1\xbe\x93\x00\xe1\xbc\xab\xce\x99\0" /* offset 757 */
 "\xe1\xbe\x94\x00\xe1\xbc\xac\xce\x99\0" /* offset 767 */
 "\xe1\xbe\x95\x00\xe1\xbc\xad\xce\x99\0" /* offset 777 */
 "\xe1\xbe\x96\x00\xe1\xbc\xae\xce\x99\0" /* offset 787 */
 "\xe1\xbe\x97\x00\xe1\xbc\xaf\xce\x99\0" /* offset 797 */
 "\xe1\xbe\xa8\xe1\xbd\xa8\xce\x99\x00\xe1\xbe\xa8\0" /* offset 807 */
 "\xe1\xbe\xa9\xe1\xbd\xa9\xce\x99\x00\xe1\xbe\xa9\0" /* offset 820 */
 "\xe1\xbe\xaa\xe1\xbd\xaa\xce\x99\x00\xe1\xbe\xaa\0" /* offset 833 */
 "\xe1\xbe\xab\xe1\xbd\xab\xce\x99\x00\xe1\xbe\xab\0" /* offset 846 */
 "\xe1\xbe\xac\xe1\xbd\xac\xce\x99\x00\xe1\xbe\xac\0" /* offset 859 */
 "\xe1\xbe\xad\xe1\xbd\xad\xce\x99\x00\xe1\xbe\xad\0" /* offset 872 */
 "\xe1\xbe\xae\xe1\xbd\xae\xce\x99\x00\xe1\xbe\xae\0" /* offset 885 */
 "\xe1\xbe\xaf\xe1\xbd\xaf\xce\x99\x00\xe1\xbe\xaf\0" /* offset 898 */
 "\xe1\xbe\xa0\x00\xe1\xbd\xa8\xce\x99\0" /* offset 911 */
 "\xe1\xbe\xa1\x00\xe1\xbd\xa9\xce\x99\0" /* offset 921 */
 "\xe1\xbe\xa2\x00\xe1\xbd\xaa\xce\x99\0" /* offset 931 */
 "\xe1\xbe\xa3\x00\xe1\xbd\xab\xce\x99\0" /* offset 941 */
 "\xe1\xbe\xa4\x00\xe1\xbd\xac\xce\x99\0" /* offset 951 */
 "\xe1\xbe\xa5\x00\xe1\xbd\xad\xce\x99\0" /* offset 961 */
 "\xe1\xbe\xa6\x00\xe1\xbd\xae\xce\x99\0" /* offset 971 */
 "\xe1\xbe\xa7\x00\xe1\xbd\xaf\xce\x99\0" /* offset 981 */
 "\xe1\xbe\xbc\xce\x91\xce\x99\x00\xe1\xbe\xbc\0" /* offset 991 */
 "\xe1\xbe\xb3\x00\xce\x91\xce\x99\0" /* offset 1003 */
 "\xe1\xbf\x8c\xce\x97\xce\x99\x00\xe1\xbf\x8c\0" /* offset 1012 */
 "\xe1\xbf\x83\x00\xce\x97\xce\x99\0" /* offset 1024 */
 "\xe1\xbf\xbc\xce\xa9\xce\x99\x00\xe1\xbf\xbc\0" /* offset 1033 */
 "\xe1\xbf\xb3\x00\xce\xa9\xce\x99\0" /* offset 1045 */
 "\x00\xe1\xbe\xba\xce\x99\x00\xe1\xbe\xba\xcd\x85\0" /* offset 1054 */
 "\x00\xce\x86\xce\x99\x00\xce\x86\xcd\x85\0" /* offset 1067 */
 "\x00\xe1\xbf\x8a\xce\x99\x00\xe1\xbf\x8a\xcd\x85\0" /* offset 1078 */
 "\x00\xce\x89\xce\x99\x00\xce\x89\xcd\x85\0" /* offset 1091 */
 "\x00\xe1\xbf\xba\xce\x99\x00\xe1\xbf\xba\xcd\x85\0" /* offset 1102 */
 "\x00\xce\x8f\xce\x99\x00\xce\x8f\xcd\x85\0" /* offset 1115 */
 "\x00\xce\x91\xcd\x82\xce\x99\x00\xce\x91\xcd\x82\xcd\x85\0" /* offset 1126 */
 "\x00\xce\x97\xcd\x82\xce\x99\x00\xce\x97\xcd\x82\xcd\x85\0" /* offset 1141 */
 "\x00\xce\xa9\xcd\x82\xce\x99\x00\xce\xa9\xcd\x82\xcd\x85\0" /* offset 1156 */
};


